PROGRAM=exercise_04_35
CXX=clang++
CXXFLAGS=-Wall -Wextra -Werror -g3

run: $(PROGRAM)_a $(PROGRAM)_b $(PROGRAM)_c
	./$(PROGRAM)_a
	./$(PROGRAM)_b
	./$(PROGRAM)_c
	 
$(PROGRAM)_a: exercise_04_35_a.o | .gitignore
	$(CXX)    $(CXXFLAGS) $< -o $@
$(PROGRAM)_b: exercise_04_35_b.o | .gitignore
	$(CXX)    $(CXXFLAGS) $< -o $@
$(PROGRAM)_c: exercise_04_35_c.o | .gitignore
	$(CXX)    $(CXXFLAGS) $< -o $@
	
%.ii: %.cpp
	$(CXX) -E $(CXXFLAGS) $< -o $@
	
%.s: %.ii
	$(CXX) -S $(CXXFLAGS) $< -o $@
	
%.o: %.s
	$(CXX) -c $(CXXFLAGS) $< -o $@
	
.gitignore:
	echo $(PROGRAM) > .gitignore
	
clean:
	rm *.s *.ii *.o $(PROGRAM) .gitignore
	
.PRECIOUS: exercise_04_35_a.ii exercise_04_35_a.s exercise_04_35_a.o
.SECONDARY: exercise_04_35_a.ii exercise_04_35_a.s exercise_04_35_a.o
.PRECIOUS: exercise_04_35_b.ii exercise_04_35_b.s exercise_04_35_b.o
.SECONDARY: exercise_04_35_b.ii exercise_04_35_b.s exercise_04_35_b.o
.PRECIOUS: exercise_04_35_c.ii exercise_04_35_c.s exercise_04_35_c.o
.SECONDARY: exercise_04_35_c.ii exercise_04_35_c.s exercise_04_35_c.o

